package beautiful01.validator;

public class NotEmptyCondition implements IValidator {
	private IValidator[] validators;
	public NotEmptyCondition(IValidator... validators) {
		this.validators = validators;
	}	
	public String valid(String name, String value) {
		if (value == null || value.length() == 0) {
			return null;
		}
		for (IValidator v : validators) {
			String error = v.valid(name, value);
			if (error != null) {
				return error;
			}
		}
		return null;
	}
}
