package beautiful02.ex3.framework;

import org.seasar.extension.dataset.DataRow;
import org.seasar.extension.dataset.DataTable;

import beautiful01.validator.ColumnValidator;
import beautiful01.validator.DataRowValidator;

/**
 * C|[g̒ۃNX
 */
abstract public class AbstractImportLogic implements ImportLogic {
	/** sԍ̃ItZbglif[^͂QsڂJn邽߁j */
	public static final int LINE_NUM_OFFSET = 2;
	/** ͌؏NX */
	private DataRowValidator validator = new DataRowValidator();

	/**
	 * ͌؂̃[ǉ܂B
	 * @param v Jp̓͌؃IuWFNg
	 */
	public void addColumnValidator(ColumnValidator v) {
		validator.addColumnValidator(v);
	}

	/** 
	 * C|[g 
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult importTable(DataTable table) {
		// 1.̓f[^̌
		ImportResult result = validateTable(table);
		if (result.hasError()) {
			return result;
		}
		// 2.O
		doPreImportProcess(table, result);
		// 3.̓f[^̃JeS[C|[g鏈
		for (int i = 0; i < table.getRowSize(); i++) {
			try {
				DataRow row = table.getRow(i);
				doImportRow(row, i);
			} catch (Exception e) {
				ImportError error = new ImportError(e.getMessage());
				result.addError(error);
			}
		}
		return result;
	}

	/**
	 * ̓f[^̌
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult validateTable(DataTable table) {
		ImportResult result = new ImportResult();
		// 1.̓f[^Ŝ̌
		if (table.getRowSize() == 0) {
			result.addError(new ImportError("C|[gf[^܂B"));
		}
		// 2.sƂ̌
		for (int i = 0; i < table.getRowSize(); i++) {
			DataRow row = table.getRow(i);
			String[] errors = validator.validate(row);
			int lineNum = i + LINE_NUM_OFFSET;
			for (String error : errors) {
				result.addError(new ImportError(error, lineNum));
			}
		}
		return result;
	}

	/**
	 * 1s̃C|[giTuNXŎj
	 * @param row 1s̓̓f[^
	 * @param index 
	 */
	abstract protected void doImportRow(DataRow row, int index);
	
	/**
	 * C|[gOiTuNXł͕̎K{ł͂Ȃj
	 * @param table ̓f[^
	 * @param result C|[g
	 */
	protected void doPreImportProcess(DataTable table, ImportResult result) {
	}


}