package beautiful02.ex3.impl;

import org.apache.commons.lang.StringUtils;
import org.seasar.extension.dataset.DataRow;

import beautiful01.validator.ColumnValidator;
import beautiful01.validator.MaxLengthValidator;
import beautiful01.validator.NotEmptyCondition;
import beautiful01.validator.NumberValidator;
import beautiful01.validator.RequiredValidator;
import beautiful02.dao.CategoryDao;
import beautiful02.entity.Category;
import beautiful02.ex3.framework.AbstractImportLogic;

/**
 * JeS[}X^̃C|[g
 */
public class CategoryImportLogicImpl extends AbstractImportLogic {
	/** JeS[Dao */
	private CategoryDao categoryDao;

	/**
	 * RXgN^
	 */
	public CategoryImportLogicImpl() {
		initialize();
	}

	/**
	 * F͌؂̃[ݒ 
	 */
	private void initialize() {
		ColumnValidator colId = new ColumnValidator("id");
		colId.add(new NotEmptyCondition(new NumberValidator()));

		ColumnValidator colName = new ColumnValidator("JeS[");
		colName.add(new RequiredValidator());
		colName.add(new MaxLengthValidator(20));
		
		addColumnValidator(colId);
		addColumnValidator(colName);
	}
	
	/**
	 * JeS[DaoZbg܂B
	 * @param categoryDao JeS[Dao
	 */
	public void setCategoryDao(CategoryDao categoryDao) {
		this.categoryDao = categoryDao;
	}

	/**
	 * 1s̃C|[g
	 * @param row 1s̓̓f[^
	 * @param index 
	 */
	@Override
	protected void doImportRow(DataRow row, int index) {
		Object id = row.getValue("id");
		// NOTE:IDȂΐVKǉA΍XV
		if (id == null || StringUtils.isEmpty(id.toString())) {
			Category category = new Category();
			category.setName((String)row.getValue("JeS["));
			categoryDao.insert(category);
		} else {
			Category category = categoryDao.findById(new Integer(id.toString()));
			category.setName((String)row.getValue("JeS["));
			categoryDao.update(category);
		}
	}


}